Debian Bug report logs - #326200
xterm: please set eightBitInput: false by default so Alt is usable as such

version graph

Package: xterm; Maintainer for xterm is Debian X Strike Force <debian-x@lists.debian.org>; Source for xterm is src:xterm.

Reported by: Reuben Thomas <rrt@sc3d.org>

Date: Fri, 2 Sep 2005 11:03:07 UTC

Severity: wishlist

Merged with 534192, 729849

Found in versions xterm/297-1, xterm/4.3.0.dfsg.1-14, xterm/242-1

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 02 Sep 2005 11:59:55 +0100
Package: xterm
Version: 4.3.0.dfsg.1-14
Severity: wishlist

Please set eightBitInput: false by default so that, as in konsole and
gnome-terminal, Alt+letter combinations work in, for example, bash,
out of the box.

(I hope this is the right place to attack this problem; I discussed it
with Thomas Dickey at some length to clarify my understanding of
what's going on.)

-- System Information:
Debian Release: 3.1
Architecture: i386 (i686)
Kernel: Linux 2.6.10
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)

Versions of packages xterm depends on:
ii  libc6                    2.3.2.ds1-22    GNU C Library: Shared libraries an
ii  libexpat1                1.95.8-3        XML parsing C library - runtime li
ii  libfontconfig1           2.3.1-2         generic font configuration library
ii  libfreetype6             2.1.7-2.4       FreeType 2 font engine, shared lib
ii  libice6                  4.3.0.dfsg.1-14 Inter-Client Exchange library
ii  libncurses5              5.4-9           Shared libraries for terminal hand
ii  libsm6                   4.3.0.dfsg.1-14 X Window System Session Management
ii  libxaw7                  4.3.0.dfsg.1-14 X Athena widget set library
ii  libxext6                 4.3.0.dfsg.1-14 X Window System miscellaneous exte
ii  libxft2                  2.1.7-1         FreeType-based font drawing librar
ii  libxmu6                  4.3.0.dfsg.1-14 X Window System miscellaneous util
ii  libxpm4                  4.3.0.dfsg.1-14 X pixmap library
ii  libxrender1              0.8.3-7         X Rendering Extension client libra
ii  libxt6                   4.3.0.dfsg.1-14 X Toolkit Intrinsics
ii  xfree86-common           4.3.0.dfsg.1-14 X Window System (XFree86) infrastr
ii  xlibs                    4.3.0.dfsg.1-14 X Keyboard Extension (XKB) configu
ii  xlibs-data               4.3.0.dfsg.1-14 X Window System client data

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Wed, 03 Nov 2010 04:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 03 Nov 2010 04:57:03 GMT) Full text and rfc822 format available.

Message #10 received at 326200@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Tue, 2 Nov 2010 23:52:29 -0500
Hi,

Reuben Thomas wrote:

> Please set eightBitInput: false by default so that, as in konsole and
> gnome-terminal, Alt+letter combinations work in, for example, bash,
> out of the box.

Could you give a pointer or elaborate on the ramifications (perhaps an
example)?  Mostly I am curious.

Probably in response to your request, at some point between xterm 204
and 208 it learned an alt-sends-esc menu item to toggle this at will.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Fri, 05 Nov 2010 17:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 05 Nov 2010 17:27:03 GMT) Full text and rfc822 format available.

Message #15 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Jonathan Nieder <jrnieder@gmail.com>
Cc: 326200 <326200@bugs.debian.org>
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 5 Nov 2010 17:25:15 +0000
On 3 November 2010 04:52:29 UTC, Jonathan Nieder <jrnieder@gmail.com> wrote:
>
> Could you give a pointer or elaborate on the ramifications (perhaps an
> example)?  Mostly I am curious.

xterm(1) has the details.

> Probably in response to your request, at some point between xterm 204
> and 208 it learned an alt-sends-esc menu item to toggle this at will.

I'd much rather have this as the default. I note that urxvt also
defaults to Meta+key sending an escape (it calls the resource "meta8",
and defaults to false). I have not come across any negative
ramifications (obviously, it is no longer possible to produce certain
characters with Meta, but there are better ways to produce most
non-ASCII printing characters).

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Fri, 05 Nov 2010 18:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 05 Nov 2010 18:33:03 GMT) Full text and rfc822 format available.

Message #20 received at 326200@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: 326200 <326200@bugs.debian.org>
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 5 Nov 2010 13:30:38 -0500
Reuben Thomas wrote:
> On 3 November 2010 04:52:29 UTC, Jonathan Nieder <jrnieder@gmail.com> wrote:

>> Could you give a pointer or elaborate on the ramifications (perhaps an
>> example)?  Mostly I am curious.
>
> xterm(1) has the details.

Well, no, it doesn't.  What I was looking for was:

"emacs -nw" and similar apps do not recognize Meta+key without this
setting.

and:

>                                           I note that urxvt also
> defaults to Meta+key sending an escape (it calls the resource "meta8",
> and defaults to false). I have not come across any negative
> ramifications (obviously, it is no longer possible to produce certain
> characters with Meta, but there are better ways to produce most
> non-ASCII printing characters).

and:

Sven Joachim wrote:

| Now after reading #574396 I see that with the xterm resources
| 
| xterm*metaSendsEscape: false
| xterm*eightBitInput: false
|
| and bash as shell meta-key combinations yield non-ASCII characters,

I guess we can rely on people to keep the default of metaSendsEscape?
Or perhaps a note in README.Debian would be needed to warn people.

If you know what to do, please provide a patch. :)  Otherwise, thoughts
welcome.

Thanks.
Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Fri, 05 Nov 2010 18:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 05 Nov 2010 18:48:03 GMT) Full text and rfc822 format available.

Message #25 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Jonathan Nieder <jrnieder@gmail.com>
Cc: 326200 <326200@bugs.debian.org>, Thomas Dickey <dickey@radix.net>
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 5 Nov 2010 18:45:43 +0000
On 5 November 2010 18:30, Jonathan Nieder <jrnieder@gmail.com> wrote:

[Sorry for not understanding what you were after.]

> Sven Joachim wrote:
>
> | Now after reading #574396 I see that with the xterm resources
> |
> | xterm*metaSendsEscape: false
> | xterm*eightBitInput: false
> |
> | and bash as shell meta-key combinations yield non-ASCII characters,

This I do not understand. "metaSendsEscape" defaults to false, and it
is precisely to obtain ASCII characters (e.g. Meta-p is sent as ESC P)
that one sets eightBitInput to false. With these two settings false,
only 7-bit ASCII characters are sent! (Setting either metaSendsEscape
to true or eightBitInput to false has the result that only 7-bit ASCII
is sent.)

> I guess we can rely on people to keep the default of metaSendsEscape?

Well, if they don't, they will have read the docs.

> Or perhaps a note in README.Debian would be needed to warn people.

> If you know what to do, please provide a patch. :)  Otherwise, thoughts
> welcome.

What is wrong with patching xterm so that it defaults to eightBitInput
being false rather than true, as other terminals do? I would like to
see what Thomas Dickey thinks, in any case (Thomas, I hope you don't
mind the Cc:; see http://bugs.debian.org/326200 for the rest of this
thread.).

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Fri, 05 Nov 2010 19:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 05 Nov 2010 19:00:02 GMT) Full text and rfc822 format available.

Message #30 received at 326200@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: 326200 <326200@bugs.debian.org>, Thomas Dickey <dickey@radix.net>
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 5 Nov 2010 13:57:05 -0500
Reuben Thomas wrote:

> What is wrong with patching xterm so that it defaults to eightBitInput
> being false rather than true, as other terminals do?

Nothing I can see except that we are in a freeze.  It is probably
worth making the change anyway, but I will leave that to the emacs
users.

Re interaction with metaSendsEscape: of course it would not confuse
new users, but would existing configurations might start to misbehave?
I readily admit I do not understand the details.  Bug#574396 does not
look resolved and I am too ignorant to figure out the current state of
things.

Thanks again for reporting this --- I had been wondering why
Meta+key did not work in emacs.

Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Fri, 05 Nov 2010 21:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 05 Nov 2010 21:51:03 GMT) Full text and rfc822 format available.

Message #35 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>
Cc: Reuben Thomas <rrt@sc3d.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 5 Nov 2010 17:40:24 -0400 (EDT)
On Fri, 5 Nov 2010, Jonathan Nieder wrote:

> Reuben Thomas wrote:
>
>> What is wrong with patching xterm so that it defaults to eightBitInput
>> being false rather than true, as other terminals do?
>
> Nothing I can see except that we are in a freeze.  It is probably
> worth making the change anyway, but I will leave that to the emacs
> users.
>
> Re interaction with metaSendsEscape: of course it would not confuse
> new users, but would existing configurations might start to misbehave?

probably.  It's configurable at runtime (menu and escape sequence) because 
this is an area where half the users want it one way, the other half the 
other way.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sat, 06 Nov 2010 16:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sat, 06 Nov 2010 16:21:03 GMT) Full text and rfc822 format available.

Message #40 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Thomas Dickey <dickey@his.com>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sat, 6 Nov 2010 16:17:22 +0000
On 5 November 2010 21:40, Thomas Dickey <dickey@his.com> wrote:
> On Fri, 5 Nov 2010, Jonathan Nieder wrote:
>
>> Reuben Thomas wrote:
>>
>>> What is wrong with patching xterm so that it defaults to eightBitInput
>>> being false rather than true, as other terminals do?
>>
>> Nothing I can see except that we are in a freeze.  It is probably
>> worth making the change anyway, but I will leave that to the emacs
>> users.
>>
>> Re interaction with metaSendsEscape: of course it would not confuse
>> new users, but would existing configurations might start to misbehave?
>
> probably.  It's configurable at runtime (menu and escape sequence) because
> this is an area where half the users want it one way, the other half the
> other way.

Why do some users want it the other way? I'm still looking for a
reason (other than the one than Jonathan quoted about bash, which
seems to have things the wrong way round). This is precisely the sort
of thing that would be good to add to some documentation so that it's
obvious that both ways have pros and cons, and hence, not only will
users be able to understand which setting they are likely to want, but
also stop complaining about the default (as I am doing!). I'm also
interested to know why this is the default in xterm, but not in
gnome-terminal, konsole or unicode-rxvt. Is it the default in any
other modern terminal?

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sat, 06 Nov 2010 17:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sat, 06 Nov 2010 17:03:03 GMT) Full text and rfc822 format available.

Message #45 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sat, 6 Nov 2010 13:00:49 -0400 (EDT)
On Sat, 6 Nov 2010, Reuben Thomas wrote:

> Why do some users want it the other way? I'm still looking for a
> reason (other than the one than Jonathan quoted about bash, which

It's a way of getting the ISO-8859-1 (or equivalents in UTF-8) entered
without dead-keys, etc.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sat, 06 Nov 2010 17:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sat, 06 Nov 2010 17:18:03 GMT) Full text and rfc822 format available.

Message #50 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sat, 6 Nov 2010 13:14:59 -0400 (EDT)
On Sat, 6 Nov 2010, Reuben Thomas wrote:

> users be able to understand which setting they are likely to want, but
> also stop complaining about the default (as I am doing!). I'm also
> interested to know why this is the default in xterm, but not in
> gnome-terminal, konsole or unicode-rxvt. Is it the default in any
> other modern terminal?

None of those are "modern" in the sense that you'd like to imply.

In each case, the design dates back at least ten years (longer
in the case of rxvt-unicode, which uses the convention from rxvt
in the mid 1990s).

Likewise, the "modern" issue we're discussing is emacs's use of
a feature older than that.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 16:48:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 16:48:03 GMT) Full text and rfc822 format available.

Message #55 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Thomas Dickey <dickey@his.com>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 7 Nov 2010 16:45:17 +0000
On 6 November 2010 17:14, Thomas Dickey <dickey@his.com> wrote:
> On Sat, 6 Nov 2010, Reuben Thomas wrote:
>
>> users be able to understand which setting they are likely to want, but
>> also stop complaining about the default (as I am doing!). I'm also
>> interested to know why this is the default in xterm, but not in
>> gnome-terminal, konsole or unicode-rxvt. Is it the default in any
>> other modern terminal?
>
> None of those are "modern" in the sense that you'd like to imply.

I think that was a bad choice of word. By "modern", I meant "actively
maintained at present".

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 16:51:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 16:51:10 GMT) Full text and rfc822 format available.

Message #60 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 7 Nov 2010 11:47:11 -0500 (EST)
On Sun, 7 Nov 2010, Reuben Thomas wrote:

> On 6 November 2010 17:14, Thomas Dickey <dickey@his.com> wrote:
>> On Sat, 6 Nov 2010, Reuben Thomas wrote:
>>
>>> users be able to understand which setting they are likely to want, but
>>> also stop complaining about the default (as I am doing!). I'm also
>>> interested to know why this is the default in xterm, but not in
>>> gnome-terminal, konsole or unicode-rxvt. Is it the default in any
>>> other modern terminal?
>>
>> None of those are "modern" in the sense that you'd like to imply.
>
> I think that was a bad choice of word. By "modern", I meant "actively
> maintained at present".

In that case, gnome-terminal is debatable (it's being changed, but not
maintained except in the loosest sense of the term).

In either case, gnome-terminal and konsole haven't changed that part of
the design for a decade.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 16:51:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 16:51:11 GMT) Full text and rfc822 format available.

Message #65 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Thomas Dickey <dickey@his.com>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 7 Nov 2010 16:49:09 +0000
On 6 November 2010 17:00, Thomas Dickey <dickey@his.com> wrote:
> On Sat, 6 Nov 2010, Reuben Thomas wrote:
>
>> Why do some users want it the other way? I'm still looking for a
>> reason (other than the one than Jonathan quoted about bash, which
>
> It's a way of getting the ISO-8859-1 (or equivalents in UTF-8) entered
> without dead-keys, etc.

Under what conditions? If I set my keyboard to Greek, for example, so
that I'm entering only non-ASCII characters with most keystrokes,
uxterm faithfully shows Greek characters (with eightBitInput: false).
Sorry if I'm being obtuse, but I'd like to home in at the very least
on an extremely clear explanation for the docs.

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 16:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 16:57:06 GMT) Full text and rfc822 format available.

Message #70 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 7 Nov 2010 11:52:48 -0500 (EST)
On Sun, 7 Nov 2010, Reuben Thomas wrote:

> On 6 November 2010 17:00, Thomas Dickey <dickey@his.com> wrote:
>> On Sat, 6 Nov 2010, Reuben Thomas wrote:
>>
>>> Why do some users want it the other way? I'm still looking for a
>>> reason (other than the one than Jonathan quoted about bash, which
>>
>> It's a way of getting the ISO-8859-1 (or equivalents in UTF-8) entered
>> without dead-keys, etc.
>
> Under what conditions? If I set my keyboard to Greek, for example, so
> that I'm entering only non-ASCII characters with most keystrokes,
> uxterm faithfully shows Greek characters (with eightBitInput: false).
> Sorry if I'm being obtuse, but I'd like to home in at the very least
> on an extremely clear explanation for the docs.

It's in the manpage (though not pointing out explicitly that the 
conversion is done at a point where it's useful for UTF-8).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 17:09:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 17:09:06 GMT) Full text and rfc822 format available.

Message #75 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Thomas Dickey <dickey@his.com>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 326200 <326200@bugs.debian.org>, Debian X Strike Force <debian-x@lists.debian.org>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 7 Nov 2010 17:05:04 +0000
On 7 November 2010 16:52, Thomas Dickey <dickey@his.com> wrote:
> On Sun, 7 Nov 2010, Reuben Thomas wrote:
>
>> On 6 November 2010 17:00, Thomas Dickey <dickey@his.com> wrote:
>>>
>>> It's a way of getting the ISO-8859-1 (or equivalents in UTF-8) entered
>>> without dead-keys, etc.
>>
>> Under what conditions? If I set my keyboard to Greek, for example, so
>> that I'm entering only non-ASCII characters with most keystrokes,
>> uxterm faithfully shows Greek characters (with eightBitInput: false).
>> Sorry if I'm being obtuse, but I'd like to home in at the very least
>> on an extremely clear explanation for the docs.
>
> It's in the manpage (though not pointing out explicitly that the conversion
> is done at a point where it's useful for UTF-8).

Sorry, I must be being stupid, but can you please be explicit? I am
trying to answer the question: "when is having eightBitInput: false a
problem?". You answered "[when you want to get] ISO-8859-1 (or
equivalents in UTF-8) entered without dead-keys, etc.". But when I
have eightBitInput: false, I can quite happily enter non-ASCII
characters (i.e. "ISO-8859-1 (or equivalents in UTF-8)").

I have tried reading the man page again, and I can't find anything
that sheds light on this question.

So, once more: under what conditions does setting eightBitInput: false
prevent the straightforward input of non-ASCII characters?

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 17:54:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 17:54:09 GMT) Full text and rfc822 format available.

Message #80 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Reuben Thomas <rrt@sc3d.org>, 326200 <326200@bugs.debian.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, Debian X Strike Force <debian-x@lists.debian.org>, debian-bugs-dist@lists.debian.org
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 7 Nov 2010 12:51:09 -0500 (EST)
On Sun, 7 Nov 2010, Reuben Thomas wrote:

> On 7 November 2010 16:52, Thomas Dickey <dickey@his.com> wrote:
>> On Sun, 7 Nov 2010, Reuben Thomas wrote:
>>
>>> On 6 November 2010 17:00, Thomas Dickey <dickey@his.com> wrote:
>>>>
>>>> It's a way of getting the ISO-8859-1 (or equivalents in UTF-8) entered
>>>> without dead-keys, etc.
>>>
>>> Under what conditions? If I set my keyboard to Greek, for example, so
>>> that I'm entering only non-ASCII characters with most keystrokes,
>>> uxterm faithfully shows Greek characters (with eightBitInput: false).
>>> Sorry if I'm being obtuse, but I'd like to home in at the very least
>>> on an extremely clear explanation for the docs.
>>
>> It's in the manpage (though not pointing out explicitly that the conversion
>> is done at a point where it's useful for UTF-8).
>
> Sorry, I must be being stupid, but can you please be explicit? I am

I was referring to this paragraph, above:

       eightBitInput (class EightBitInput)
               If "true", Meta characters (a  single-byte  character  combined
               with  the  Meta  modifier key) input from the keyboard are pre-
               sented as a single character with the  eighth  bit  turned  on.
               The  terminal is put into 8-bit mode.  If "false", Meta charac-
               ters are converted into a two-character sequence with the char-
               acter  itself  preceded by ESC.  On startup, xterm tries to put
               the terminal into 7-bit mode.  The metaSendsEscape and altSend-
               sEscape resources may override this.  The default is "true."

which in context refers to this chunk of code in input.c
            if (eightbit && (kd.nbytes == 1) && screen->input_eight_bits) {
                IChar ch = CharOf(kd.strbuf[0]);
                if (ch < 128) {
                    kd.strbuf[0] |= (char) 0x80;
                    TRACE(("...input shift from %d to %d (%#x to %#x)\n",
                           ch, CharOf(kd.strbuf[0]),
                           ch, CharOf(kd.strbuf[0])));
#if OPT_WIDE_CHARS
                    if (screen->utf8_mode) {
                        /*
                         * We could interpret the incoming code as "in the
                         * current locale", but it's simpler to treat it as
                         * a Unicode value to translate to UTF-8.
                         */
                        ch = CharOf(kd.strbuf[0]);
                        kd.nbytes = 2;
                        kd.strbuf[0] = (char) (0xc0 | ((ch >> 6) & 0x3));
                        kd.strbuf[1] = (char) (0x80 | (ch & 0x3f));
                        TRACE(("...encoded %#x in UTF-8 as %#x,%#x\n",
                               ch, CharOf(kd.strbuf[0]), CharOf(kd.strbuf[1])));
                    }
#endif
                }
                eightbit = False;
            }

> trying to answer the question: "when is having eightBitInput: false a
> problem?". You answered "[when you want to get] ISO-8859-1 (or
> equivalents in UTF-8) entered without dead-keys, etc.". But when I
> have eightBitInput: false, I can quite happily enter non-ASCII
> characters (i.e. "ISO-8859-1 (or equivalents in UTF-8)").
>
> I have tried reading the man page again, and I can't find anything
> that sheds light on this question.



> So, once more: under what conditions does setting eightBitInput: false
> prevent the straightforward input of non-ASCII characters?

I suppose as long as the only users you're considering are using gnome or 
KDE, then that's true.  (There's nothing for setting keyboard here, using
fvwm).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 19:39:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 19:39:03 GMT) Full text and rfc822 format available.

Message #85 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Riku Saikkonen <rjs@cs.hut.fi>
Cc: Reuben Thomas <rrt@sc3d.org>, 326200@bugs.debian.org
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 7 Nov 2010 14:37:04 -0500 (EST)
[Message part 1 (text/plain, inline)]
On Sun, 7 Nov 2010, Riku Saikkonen wrote:

> (I'm just a long-time xterm user who follows the Debian bug reports
> every now and then...)
>
> Reuben Thomas <rrt@sc3d.org> writes:
>> On 6 November 2010 17:00, Thomas Dickey <dickey@his.com> wrote:
> [about "*eightBitInput: true" being the default]
>>> It's a way of getting the ISO-8859-1 (or equivalents in UTF-8) entered
>>> without dead-keys, etc.
>> Under what conditions? If I set my keyboard to Greek, for example, so
>> that I'm entering only non-ASCII characters with most keystrokes,
>> uxterm faithfully shows Greek characters (with eightBitInput: false).
>
> Here is a concrete example that I've been using for years, ever since
> I first learned it:
>
> If I type Alt-0, I get the DEGREE SIGN character '°'. However, if I run
>  xterm -xrm '*eightBitInput: false'
> then Alt-0 gives me ^[0 (i.e. ESC + 0) instead. Same with, e.g., Alt-7
> to get the MIDDLE DOT '·' or Alt-w to get the DIVISION SIGN '÷' or
> Alt-Shift-w to get the MULTIPLICATION SIGN '×'.
>
> I can of course (as I learned later) get the degree sign character
> also using "Compose ^ 0" (presuming that I have a Compose key
> configured and, of course, that I know about this). But Alt-0 is
> quicker to type and (it seems to me) easier to remember.
>
> Of course, the downside is that Alt-0 in Emacs gives the ° character
> instead of the Emacs command M-0 (e.g., Alt-7 * gives me either
> '*******' or '·*' depending on the eightBitInput setting).
>
> In Emacs running in its own X window (instead of under xterm):
>  Alt-7 * gives '*******'
> which would suggest using *eightBitInput: false to be consistent.
> However, it is not really completely consistent using either value of
> eightBitInput:
>  C-q Alt-7 gives '·' in Emacs running under an X window
>  C-q Alt-7 gives '·' in Emacs under xterm with *eightBitInput: true
>  C-q Alt-7 gives '^[*' in Emacs under xterm with *eightBitInput: false
> So the behaviour of C-q Alt-7 would suggest *eightBitInput: true
> (especially since there are fewer ways of getting '·' with
> eightBitInput: false). I guess C-q Alt-7 giving '·' in an X window is
> a decision made by Emacs developers sometime in the past (in an Emacs
> X window, it is of course more useful to get '·' than '^[*' from this
> special command).
>
> So both *eightBitInput: false and *eightBitInput: true are useful in
> their own ways. This probably really is a user preference (for power
> users, at least), so I guess both *eightBitInput: true and
> *eightBitInput: false are going to annoy some users. However, I guess
> it would be useful for Debian to be consistent about this in all the
> terminals it ships (including the Linux and kFreeBSD text consoles as
> well as X terminal emulators).
>
> I'm personally not really sure which option I prefer: I'm used to the
> Debian default of *eightBitInput: true, and use it every now and then
> (as I described above), but it's also annoying that I have to use ESC
> in Emacs so much... Maybe *eightBitInput: false would be less
> surprising for new users of Emacs under xterm (since Alt-x would work
> as M-x, and not many people seem to know that, e.g., Alt-0 could be
> the degree sign).

yes - but

Similarly - I use the backarrow-key menu entry often, since Linux happens 
to be the only platform using DEL rather than BS.

> I suppose this clearly is not something that should be changed while
> in a freeze, especially since xterm in Debian has had the current
> behaviour for so many years. But perhaps it would be possible to
> coordinate a consistent behaviour for all the terminals in the next
> Debian release after this frozen one?

It's really up to Debian to decide what they want to do in their packages,
and why.

xterm's the only terminal mentioned which actually _implements_
meta mode, which seems to be confused with sending escape characters.

Since sending escape characters seems to be the only validly-expressed
goal, that's done better by the metaSendsEscape resource.  I made that
a menu entry, so it could be changed back and forth.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 07 Nov 2010 19:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to rjs@cs.hut.fi (Riku Saikkonen):
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 07 Nov 2010 19:54:03 GMT) Full text and rfc822 format available.

Message #90 received at 326200@bugs.debian.org (full text, mbox):

From: rjs@cs.hut.fi (Riku Saikkonen)
To: Reuben Thomas <rrt@sc3d.org>
Cc: 326200@bugs.debian.org, Thomas Dickey <dickey@his.com>
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 07 Nov 2010 21:26:02 +0200
(I'm just a long-time xterm user who follows the Debian bug reports
every now and then...)

Reuben Thomas <rrt@sc3d.org> writes:
>On 6 November 2010 17:00, Thomas Dickey <dickey@his.com> wrote:
[about "*eightBitInput: true" being the default]
>> It's a way of getting the ISO-8859-1 (or equivalents in UTF-8) entered
>> without dead-keys, etc.
>Under what conditions? If I set my keyboard to Greek, for example, so
>that I'm entering only non-ASCII characters with most keystrokes,
>uxterm faithfully shows Greek characters (with eightBitInput: false).

Here is a concrete example that I've been using for years, ever since
I first learned it:

If I type Alt-0, I get the DEGREE SIGN character '°'. However, if I run
  xterm -xrm '*eightBitInput: false'
then Alt-0 gives me ^[0 (i.e. ESC + 0) instead. Same with, e.g., Alt-7
to get the MIDDLE DOT '·' or Alt-w to get the DIVISION SIGN '÷' or
Alt-Shift-w to get the MULTIPLICATION SIGN '×'.

I can of course (as I learned later) get the degree sign character
also using "Compose ^ 0" (presuming that I have a Compose key
configured and, of course, that I know about this). But Alt-0 is
quicker to type and (it seems to me) easier to remember.

Of course, the downside is that Alt-0 in Emacs gives the ° character
instead of the Emacs command M-0 (e.g., Alt-7 * gives me either
'*******' or '·*' depending on the eightBitInput setting).

In Emacs running in its own X window (instead of under xterm):
  Alt-7 * gives '*******'
which would suggest using *eightBitInput: false to be consistent.
However, it is not really completely consistent using either value of
eightBitInput:
  C-q Alt-7 gives '·' in Emacs running under an X window
  C-q Alt-7 gives '·' in Emacs under xterm with *eightBitInput: true
  C-q Alt-7 gives '^[*' in Emacs under xterm with *eightBitInput: false
So the behaviour of C-q Alt-7 would suggest *eightBitInput: true
(especially since there are fewer ways of getting '·' with
eightBitInput: false). I guess C-q Alt-7 giving '·' in an X window is
a decision made by Emacs developers sometime in the past (in an Emacs
X window, it is of course more useful to get '·' than '^[*' from this
special command).

So both *eightBitInput: false and *eightBitInput: true are useful in
their own ways. This probably really is a user preference (for power
users, at least), so I guess both *eightBitInput: true and
*eightBitInput: false are going to annoy some users. However, I guess
it would be useful for Debian to be consistent about this in all the
terminals it ships (including the Linux and kFreeBSD text consoles as
well as X terminal emulators).

I'm personally not really sure which option I prefer: I'm used to the
Debian default of *eightBitInput: true, and use it every now and then
(as I described above), but it's also annoying that I have to use ESC
in Emacs so much... Maybe *eightBitInput: false would be less
surprising for new users of Emacs under xterm (since Alt-x would work
as M-x, and not many people seem to know that, e.g., Alt-0 could be
the degree sign).

I suppose this clearly is not something that should be changed while
in a freeze, especially since xterm in Debian has had the current
behaviour for so many years. But perhaps it would be possible to
coordinate a consistent behaviour for all the terminals in the next
Debian release after this frozen one?

-- 
-=- Rjs -=- rjs@cs.hut.fi, Riku.Saikkonen@hut.fi




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Thu, 01 Dec 2011 22:03:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 01 Dec 2011 22:03:12 GMT) Full text and rfc822 format available.

Message #95 received at 326200@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Thu, 1 Dec 2011 15:58:22 -0600
Hi again,

Riku Saikkonen wrote:

> I suppose this clearly is not something that should be changed while
> in a freeze, especially since xterm in Debian has had the current
> behaviour for so many years. But perhaps it would be possible to
> coordinate a consistent behaviour for all the terminals in the next
> Debian release after this frozen one?

That sounded sensible to my innocent bystander ears. :)  Reuben, would
you be willing to coordinate this (or do you know anyone who would be)?

That means:

 1. Finding out what the major terminals in Debian currently do.  If
    xterm is not the odd man out, finding a consensus, for example by
    reporting a bug against the debian-policy package with
    X-Debbugs-Cc pointing to the relevant maintainers.

 2. Proposing a patch for xterm bug#326200.

 3. Proposing a patch for bash bug#574396.

 4. Being ready to help people respond to bugs that arise from the
    above.

If one wants to make this change and find relevant bugs in time for
wheezy, now's probably the time.

Thanks and hope that helps,
Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Thu, 01 Dec 2011 22:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 01 Dec 2011 22:57:03 GMT) Full text and rfc822 format available.

Message #100 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Jonathan Nieder <jrnieder@gmail.com>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Thu, 1 Dec 2011 23:52:51 +0100
On 1 December 2011 22:58, Jonathan Nieder <jrnieder@gmail.com> wrote:
> Hi again,
>
> Riku Saikkonen wrote:
>
>> I suppose this clearly is not something that should be changed while
>> in a freeze, especially since xterm in Debian has had the current
>> behaviour for so many years. But perhaps it would be possible to
>> coordinate a consistent behaviour for all the terminals in the next
>> Debian release after this frozen one?
>
> That sounded sensible to my innocent bystander ears. :)  Reuben, would
> you be willing to coordinate this (or do you know anyone who would be)?

I don't actually use Debian at present; I use Ubuntu. That may limit
my usefulness. However, at the very least, I'd be happy to try doing
this:

>  1. Finding out what the major terminals in Debian currently do.  If
>    xterm is not the odd man out, finding a consensus, for example by
>    reporting a bug against the debian-policy package with
>    X-Debbugs-Cc pointing to the relevant maintainers.

What counts as "the major terminals"? Obviously xterm, uxterm,
gnome-terminal, konsole, and which others? Should I use popcon to find
out (how?)? Or can we draw up an arbitrary list? Basic use of
apt-cache search and grep suggests the following:

gnome-terminal
xterm
eterm
evilvte
guake
kterm
lxterminal
mlterm
mlterm-tiny
mrxvt
mrxvt-cjk
mrxvt-mini
pterm
roxterm
rxvt
rxvt-beta
rxvt-ml
rxvt-unicode
rxvt-unicode-256color
rxvt-unicode-lite
sakura
terminal.app
terminator
vala-terminal
wterm
wterm-ml
xfce4-terminal
xvt
konsole

I'd be quite happy to whip through that lot and see what the defaults are.

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Thu, 01 Dec 2011 23:18:57 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 01 Dec 2011 23:18:57 GMT) Full text and rfc822 format available.

Message #105 received at 326200@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Thu, 1 Dec 2011 17:16:55 -0600
Reuben Thomas wrote:

> I don't actually use Debian at present; I use Ubuntu. That may limit
> my usefulness. However, at the very least, I'd be happy to try doing
> this:

Thanks.  Unless the Ubuntu maintainers want to make this change as a
differentiating feature instead of pushing it in Debian (and I can't
see the point to that), I think you are still affected by what happens
in Debian anyway.

[...]
> Basic use of
> apt-cache search and grep suggests the following:

Yep, that seems like a sensible list.

> I'd be quite happy to whip through that lot and see what the defaults are.

Great.  It might even be possible to automate that with some ncurses
magic, but don't ask me how. :)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Fri, 02 Dec 2011 07:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 02 Dec 2011 07:39:04 GMT) Full text and rfc822 format available.

Message #110 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Jonathan Nieder <jrnieder@gmail.com>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 2 Dec 2011 08:32:23 +0100
On 2 December 2011 00:16, Jonathan Nieder <jrnieder@gmail.com> wrote:
> Reuben Thomas wrote:
>
>> I don't actually use Debian at present; I use Ubuntu. That may limit
>> my usefulness. However, at the very least, I'd be happy to try doing
>> this:
>
> Thanks.  Unless the Ubuntu maintainers want to make this change as a
> differentiating feature instead of pushing it in Debian (and I can't
> see the point to that), I think you are still affected by what happens
> in Debian anyway.

Of course, and that is why I filed the bug in Debian. The point I'm
making is that I've tested Ubuntu packages on an Ubuntu oneiric
system, not Debian packages on a Debian system.

Here are the results of my tests:

Xterm & friends:

xterm: true (eightBitInput resource)
kterm: true (eightBitInput resource)
mlterm: true (--meta=esc command line option)
xvt: true (-7 command line option)

GNUStep (I imagine that GNUStep standards mean you wouldn't want to
change the default):

terminal.app: true (no option, but can remap keys)

rxvt & friends:

rxvt: false (meta8 resource)
rxvt-unicode: false (meta8 resource)
mrxvt: false (-m8/+m8 command line option)
wterm: false (-meta8 command line option)
aterm: false (-meta8 command line option)

libvte-based emulators (for at least some of these may need to select
preference “Keyboard→Disable other menu shortcut keys”, otherwise
Alt+some letters opens menu; again, this default probably shouldn't
change):

gnome-terminal: false (no option)
evilvte: false (no option)
guake: false (no option)
lxterminal: false (no option)
roxterm: false (no option)
sakura: false (no option)
terminator: false (no option)
vala-terminal: false (no option)
xfce4-terminal: false (no option)
konsole: false (no option)

Others:

eterm: false (--meta8 command line option)
pterm: false (no option)

In other words, only xterm, kterm, mlterm and xvt would require a
patch, and in all cases it would be simply to reverse an existing
default setting.

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Fri, 02 Dec 2011 08:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 02 Dec 2011 08:06:04 GMT) Full text and rfc822 format available.

Message #115 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Jonathan Nieder <jrnieder@gmail.com>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Fri, 2 Dec 2011 09:02:38 +0100
On 1 December 2011 22:58, Jonathan Nieder <jrnieder@gmail.com> wrote:

>  2. Proposing a patch for xterm bug#326200.

For xterm, kterm and xvt, the simplest thing to do would seem to be to
add a suitable default resource to the various /etc/X11/app-defaults
files. (xvt doesn't install such a file, but since it respects
resources it presumably could.)

For mlterm a simple patch to reverse the default would be required.

How does this sound?

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 04 Dec 2011 16:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 04 Dec 2011 16:57:03 GMT) Full text and rfc822 format available.

Message #120 received at 326200@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 4 Dec 2011 10:55:05 -0600
Reuben Thomas wrote:

> For xterm, kterm and xvt, the simplest thing to do would seem to be to
> add a suitable default resource to the various /etc/X11/app-defaults
> files. (xvt doesn't install such a file, but since it respects
> resources it presumably could.)
>
> For mlterm a simple patch to reverse the default would be required.
>
> How does this sound?

Sounds sensible to me.  I think the first step is to file a bug
against debian-policy with X-Debbugs-Cc pointing to the relevant
maintainers, so the new Right Thing To Do™ can be documented to avoid
future regressions.

It feels awkward to give advice like this without doing anything
myself.  Please don't take it as authoritative --- what the people
actually working on these packages are happy with is more important.

Many thanks,
Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 04 Dec 2011 20:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Reuben Thomas <rrt@sc3d.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 04 Dec 2011 20:33:03 GMT) Full text and rfc822 format available.

Message #125 received at 326200@bugs.debian.org (full text, mbox):

From: Reuben Thomas <rrt@sc3d.org>
To: Jonathan Nieder <jrnieder@gmail.com>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 4 Dec 2011 21:31:12 +0100
On 4 December 2011 17:55, Jonathan Nieder <jrnieder@gmail.com> wrote:
> Reuben Thomas wrote:
>
>> For xterm, kterm and xvt, the simplest thing to do would seem to be to
>> add a suitable default resource to the various /etc/X11/app-defaults
>> files. (xvt doesn't install such a file, but since it respects
>> resources it presumably could.)
>>
>> For mlterm a simple patch to reverse the default would be required.
>>
>> How does this sound?
>
> Sounds sensible to me.  I think the first step is to file a bug
> against debian-policy with X-Debbugs-Cc pointing to the relevant
> maintainers, so the new Right Thing To Do™ can be documented to avoid
> future regressions.

Could you possibly file that bug? I'm abroad for a week, and don't
really have the mental space to do something delicate like that which
I've never done before. I think the advice is simple enough: add an
eightBitInput: true resource to each term's default resources file,
plus a default-negating patch to mlterm.

-- 
http://rrt.sc3d.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Mon, 05 Dec 2011 08:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Mon, 05 Dec 2011 08:06:04 GMT) Full text and rfc822 format available.

Message #130 received at 326200@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Reuben Thomas <rrt@sc3d.org>
Cc: "Aaron M. Ucko" <ucko@debian.org>, Riku Saikkonen <rjs@cs.hut.fi>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Mon, 5 Dec 2011 02:03:39 -0600
Reuben Thomas wrote:
> On 4 December 2011 17:55, Jonathan Nieder <jrnieder@gmail.com> wrote:

>> Sounds sensible to me.  I think the first step is to file a bug
>> against debian-policy with X-Debbugs-Cc pointing to the relevant
>> maintainers, so the new Right Thing To Do™ can be documented to avoid
>> future regressions.
>
> Could you possibly file that bug?

Filed: http://bugs.debian.org/651035




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Thu, 08 Dec 2011 10:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to rjs@cs.hut.fi (Riku Saikkonen):
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 08 Dec 2011 10:30:07 GMT) Full text and rfc822 format available.

Message #135 received at 326200@bugs.debian.org (full text, mbox):

From: rjs@cs.hut.fi (Riku Saikkonen)
To: Reuben Thomas <rrt@sc3d.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, "Aaron M. Ucko" <ucko@debian.org>, 326200@bugs.debian.org
Subject: Re: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Thu, 08 Dec 2011 11:59:46 +0200
Reuben Thomas <rrt@sc3d.org> writes:
>In other words, only xterm, kterm, mlterm and xvt would require a
>patch, and in all cases it would be simply to reverse an existing
>default setting.

There are a few more terminals to add to your list of Meta-key
behaviors: the text consoles of the kernels supported by Debian.

Linux text console: false

(That is, by default Alt+w sends ^[w and not the DIVISION SIGN
character, at least on my i386 system. This appears to be changeable via
setmetamode(1), which uses the KDSKBMETA ioctl documented in
console_ioctl(4). I did not find the smm or rmm terminfo entries for
linux, nor code that would implement such escape sequences to change the
meta mode. I think the default is set in #define KBD_DEFMODE in
linux/drivers/char/keyboard.c (search in the file for the two
occurrences of "VC_META").)

I don't have a Debian GNU/kFreeBSD system to test on, nor Debian
GNU/Hurd. Maybe someone else could test those for completeness?

-- 
-=- Rjs -=- rjs@cs.hut.fi, Riku.Saikkonen@hut.fi




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Thu, 08 Dec 2011 10:42:52 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 08 Dec 2011 10:43:13 GMT) Full text and rfc822 format available.

Message #140 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 326200@bugs.debian.org
Cc: 326200-submitter@bugs.debian.org
Subject: Re: Bug#326200: xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Thu, 08 Dec 2011 05:40:57 -0500
[Message part 1 (text/plain, inline)]
On Thu, Dec 08, 2011 at 11:59:46AM +0200, Riku Saikkonen wrote:
> Reuben Thomas <rrt@sc3d.org> writes:
> >In other words, only xterm, kterm, mlterm and xvt would require a
> >patch, and in all cases it would be simply to reverse an existing
> >default setting.
> 
> There are a few more terminals to add to your list of Meta-key
> behaviors: the text consoles of the kernels supported by Debian.
> 
> Linux text console: false
                      unimplemented (as are most of the cases mentioned)

man terminfo(5):

       If the terminal has a ``meta key'' which acts as a shift  key,  setting
       the  8th  bit  of any character transmitted, this fact can be indicated
       with km.  Otherwise, software will assume that the 8th  bit  is  parity
       and  it  will usually be cleared.  If strings exist to turn this ``meta
       mode'' on and off, they can be given as smm and rmm.

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to Reuben Thomas <rrt@sc3d.org>:
Bug#326200. (Thu, 08 Dec 2011 10:43:27 GMT) Full text and rfc822 format available.

Merged 326200 534192. Request was from Thomas Dickey <dickey@his.com> to control@bugs.debian.org. (Sat, 17 Dec 2011 00:03:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Sun, 08 Jan 2012 14:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 08 Jan 2012 14:42:03 GMT) Full text and rfc822 format available.

Message #150 received at 326200@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 326200@bugs.debian.org
Cc: 326200-submitter@bugs.debian.org
Subject: re: #326200 xterm: please set eightBitInput: false by default so Alt is usable as such
Date: Sun, 08 Jan 2012 09:38:58 -0500
[Message part 1 (text/plain, inline)]
There are two relevant issues:
	(a) how to configure a terminal to send an escape character as
	    a prefix.
	(b) how to configure a terminal to handle meta-key processing.

Notwithstanding the confusion arising from bash, they're different.

Even if all of the terminals are (for the ones that handle this),
configured to support (a), there are still functional differences
in (a), which are well-known, having been the subject of other bug
reports.

For (b), it appears that xterm (and some others such as kterm which
derive from the same source) are the only ones that implement the
meta key feature as documented in terminfo(5).  Specifically, the
features is not implemented in any source based on rxvt, vte, putty,
or kde.

In xterm #277, I've addressed (b):

       eightBitMeta (class EightBitMeta)
               This  controls  the way xterm modifies the eighth bit of a sin-
               gle-byte key when  the  eightBitInput  resource  is  set.   The
               default is "locale".

               The  resource  value  is a string, evaluated as a boolean after
               startup.

               false
                    The key is sent unmodified.

               locale
                    The key is modified only  if  the  locale  uses  eight-bit
                    encoding.

               true The key is sent modified.

               never
                    The key is always sent unmodified.

               Except for the never choice, xterm honors the terminfo capabil-
               ities smm (set meta mode) and rmm (reset meta  mode),  allowing
               the feature to be turned on or off dynamically.

               If  eightBitMeta  is  enabled when the locale uses UTF-8, xterm
               encodes the value as UTF-8 (since patch #183 in 2003).

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to Reuben Thomas <rrt@sc3d.org>:
Bug#326200. (Sun, 08 Jan 2012 14:42:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#326200; Package xterm. (Thu, 04 Oct 2012 18:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thorsten Glaser <tg@mirbsd.de>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 04 Oct 2012 18:45:06 GMT) Full text and rfc822 format available.

Message #158 received at 326200@bugs.debian.org (full text, mbox):

From: Thorsten Glaser <tg@mirbsd.de>
To: 326200@bugs.debian.org
Subject: Please keep xterm doing Alt-d=ä as this is how I type German
Date: Thu, 4 Oct 2012 20:43:34 +0200 (CEST)
Hi,

FWIW: the BSD wscons(4) text console does the same,
and it always annoys me that Linux’ doesn’t…

bye,
//mirabilos
-- 
15:41⎜<Lo-lan-do:#fusionforge> Somebody write a testsuite for helloworld :-)



Marked as found in versions xterm/297-1. Request was from Sven Joachim <svenjoac@gmx.de> to 729849-submit@bugs.debian.org. (Fri, 22 Nov 2013 11:03:09 GMT) Full text and rfc822 format available.

Merged 326200 534192 729849 Request was from Sven Joachim <svenjoac@gmx.de> to 729849-submit@bugs.debian.org. (Fri, 22 Nov 2013 11:03:11 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 19:55:30 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.